//#target illustrator; //対象のアプリが起動しスクリプトが実行
//#targetengine adobe;  //常駐型スクリプト」なのでスクリプトを実行する空間を#targetengineで設定

//ウインドウパネルの設定
var win = new Window('dialog','サイズ',[100,100,275,350]);//paletteタイプのウィンドウを選択
var chkBox01 = win.add("checkbox",[10,10,80,30],"ヨコ寸法");
var btn01 = win.add("radiobutton",[90,10,140,30],"上");
var btn02 = win.add("radiobutton",[130,10,170,30],"下");
var chkBox02 = win.add("checkbox",[10,35,80,55],"タテ寸法");
var btn03 = win.add("radiobutton",[90,35,125,55],"左");
var btn04 = win.add("radiobutton",[130,35,165,55],"右");
win.add("statictext",[10,80,115,110],"フォントサイズ：");
var font = win.add("edittext",[115,85,145,110],"10");
win.add("statictext",[150,85,180,110],"pt");
win.add("statictext",[10,110,120,130],"引出し距離：");
var drawer = win.add("edittext",[90,110,120,130],"7");
win.add("statictext",[130,110,170,130],"mm");
win.add("statictext",[10,135,70,150],"縮尺率：");
var btn07 = win.add("radiobutton",[60,135,110,150],"原寸");
var btn08 = win.add("radiobutton",[115,135,170,150],"1/10");
var btn09 = win.add("radiobutton",[10,160,170,175],"その他:1/");
var scale = win.add("edittext",[100,160,170,180],"");
var clickBtn = win.add("button",[10,190,160,230],"寸法表示");

//初期設定ここから
chkBox01.value = true;
btn01.value = true;
btn02.value = false;
chkBox02.value = true;
btn03.value = false;
btn04.value = true;
btn07.value = true;
btn08.value = false;
btn09.value = false;
//初期設定ここまで
//ウインドウパネルの設定ここまで

clickBtn.onClick = function(){
    { win.close(); }//ダイアログを閉じる
    var docObj = activeDocument;
    var selObj = docObj.selection;
    var aLayerObj = docObj.activeLayer;

    for(var i=0; i<selObj.length; i++){
        //オブジェクトの計測ここから
        var width = selObj[i].width; //オブジェクトの横幅を測る
        var height = selObj[i].height; //オブジェクトの縦幅を測る
        var x1 = selObj[i].geometricBounds[0] //オブジェクトのX座標　左
        var y1 = selObj[i].geometricBounds[1] //オブジェクトのY座標　上
        var x2 = selObj[i].geometricBounds[2] //オブジェクトのX座標　右
        var y2 = selObj[i].geometricBounds[3] //オブジェクトのｙ座標　下
        //オブジェクトの計測ここまで

        //ptの換算ここから
        w = new UnitValue(width, "pt"); //横幅
        h = new UnitValue(height, "pt"); //縦幅
        //ptの換算ここまで

        //単位をmmに変換ここから
        wMM = w.as("mm")
        hMM = h.as("mm")
        //単位をmmに変換ここまで

        //少数点　第３位まで表示ここから
        var wMM = point(wMM);
        var hMM = point(hMM);
        //少数点　第３位まで表示ここまで

        //テキストを数字に変換ここから
        var fontSize = eval(font.text); //フォントサイズ
        var drawerMm = eval(drawer.text);   //引き出線
        //テキストを数字に変換ここまで

        d = new UnitValue(drawerMm, "mm");  //ｐｔの換算
        dtp = d.as("pt");   //単位をptに変換

        //横幅の設定ここから
        if(chkBox01.value === true){
            if(wMM > 0){
                var txtObjW = aLayerObj.textFrames.add();
                txtObjW.contents = (wMM * rate()) + "mm";   //rate() 関数
                if(btn01.value === true){
                    txtObjW.position = [x1 + (width / 2),y1 + (dtp + 25)];
                } else {
                    txtObjW.position = [x1 + (width / 2),y2 - (dtp + 10)];
                };
                txtObjW.paragraphs[0].justification = Justification.CENTER;     //文字のセンター揃え
                txtObjW.paragraphs[0].fillColor = setCMYKColor(0,0,0,80);       //塗り指定
                txtObjW.paragraphs[0].size = fontSize;                          //文字サイズ
                txtObjW.note = "横　寸法";                                       //属性
                
                var lineObjW = aLayerObj.pathItems.add();
                if(btn01.value === true){
                    lineObjW.setEntirePath([[x1,y1 + dtp],[x1,y1 + (dtp + 8.5)],[x2,y1 + (dtp + 8.5)],[x2,y1 + dtp]]);
                } else {
                    lineObjW.setEntirePath([[x1,y2 - dtp],[x1,y2 - (dtp + 8.5)],[x2,y2 - (dtp + 8.5)],[x2,y2 - dtp]]);
                };
                lineObjW.filled = false;
                lineObjW.stroked = true;
                lineObjW.strokeWidth = 0.283;
                lineObjW.strokeColor = setCMYKColor(0,0,0,80);
                lineObjW.note = "横　引き出し線";
            };
        };
        //横幅の設定ここまで
       //縦幅の設定ここから
        if(chkBox02.value === true){
            if(hMM > 0){
                var txtObjH = aLayerObj.textFrames.add();
                txtObjH.contents = (hMM * rate()) + 'mm';
                if(btn03.value === true){
                    txtObjH.position = [x1 - (dtp + 15),y1 - (height/2.2)];
                    txtObjH.paragraphs[0].justification = Justification.RIGHT;
                }else {
                    txtObjH.position = [x2 + (dtp + 15),y1 - (height/2.2)];
                    txtObjH.paragraphs[0].justification = Justification.LEFT;
                };
                txtObjH.paragraphs[0].fillColor = setCMYKColor(0,0,0,80);
                txtObjH.paragraphs[0].size = fontSize;
                txtObjH.note = '縦　寸法';

                var lineObjH = aLayerObj.pathItems.add();
                if(btn03.value === true){
                    lineObjH.setEntirePath([[x1 - dtp,y1],[x1 - (dtp + 8.5),y1],[x1 - (dtp + 8.5),y2],[x1 - dtp,y2]]);//右に表示
                }else{
                    lineObjH.setEntirePath([[x2 + dtp,y1],[x2 + (dtp + 8.5),y1],[x2 + (dtp + 8.5),y2],[x2 + dtp,y2]]);//左に表示
                };
                lineObjH.filled = false;
                lineObjH.stroked = true;
                lineObjH.strokeWidth = 0.283;
                lineObjH.strokeColor = setCMYKColor(0,0,0,80);
                lineObjH.note = '縦　引き出し線';
            };
        };//縦幅の設定ここまで
    };//for

};//function fafa()

//小数点第３位まで表示する計算式
function point(num){
    return Math.round(num * 1000) / 1000;
};

//CMYKの設定
function setCMYKColor(c,m,y,k){
    var CMYK = new CMYKColor();
    CMYK.cyan = c;
    CMYK.magenta = m;
    CMYK.yellow = y;
    CMYK.black = k;
    return CMYK;
};

//縮尺率の計算式
function rate(){
    if(btn07.value === true){
        var ed = 1;
    }else {
        if(btn08.value === true){
            var ed = 10 ;
        } else {
            if(btn09.value === true){
                var ygyg = eval(scale.text);
                var ed = ygyg;
            }else{};
        };
    };
    return ed ;
};
win.show();